/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

#include "10-1.cc"
#include <string>

//   ߰  ̴.
static int this_is_an_X_environment = 0;

class XWindow;

class EditWindow {
public:
    void w_addch(char x)       { window->w_addch(x); }
    void w_addstr(string x)    { window->w_addstr(x); }
    void w_clear()             { window->w_clear(); }
    // . . . .
    EditWindow()               { if (this_is_an_X_environment) {
                                   window = new XWindow;
                                   // . . . . 
                                 } else {
                                   window = new CursesWindow;
                                   // . . . .
                               } }
private:
    Window *window;
    short topLine, bottomLine;
};
