/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

//   ߰ Ŭ: Point, TaxPayer, Revenue
class Point {
};

class TaxPayer {
public:
    const char *name() { };
    const char *ssn() { };
};

class Revenue {
public:
    const char *income() { }
};

class TaxFormFramework {
public:
    TaxFormFramework(int numberOfLines) {
        // . . . .
    }
    void draw() {
        makeField(loc1, taxpayer.name());
        makeField(loc2, taxpayer.ssn());
        // . . . .
        addFields();
    }
private:
    // Ļ Ŭ ݵ  addFields  ؾ Ѵ.
    virtual void addFields() = 0;
    Point loc1, loc2; // . . . .
    TaxPayer taxpayer;
    // . . . .
// makeField Լ protected ؾ Ļ Ŭ  ϴ.
protected:
    void makeField(Point, const char *const);
};

class ScheduleB: public TaxFormFramework {
public:
    ScheduleB(): TaxFormFramework(14) { }
private:
    Point locA, locB; // . . . . 
    void addFields() {
        //  B   ߰Ѵ.
        makeField(locA, mortgage.income());
        makeField(locB, other.income());
        // . . . .
    }
    Revenue mortgage, other;
    // . . . .
};

