/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

#include <iostream.h>
#include <stddef.h>
// placement new ϱ   Ŭؾ Ѵ.
#include <new>

// gcc 2.9x ⺻ placement new   ϰ ִ.
// inline void *operator new(size_t, void *place) throw() { return place; }
//   ϴ new Լ θ ּóؾ߸ Ѵ.
// void *operator new(size_t, void *p) { return p; }

class Foo {
public:
    Foo() { rep = 1; }
    Foo(int i) { rep = i; }
    ~Foo() { rep = 0; }
    // ڿ   ߴ.
    void print() { cout << rep << endl; }
private:
    int rep;
};

static struct { int:0; } dummy;  // - (alignment)
char foobar[sizeof(Foo)];

Foo foefum;

int main()
{
    foefum.print();
    (&foefum)->Foo::~Foo();   //  ģ ü    ʷ
    foefum.print();           // ǵ  !
    Foo *fooptr = new(foobar) Foo;
    fooptr->print();
    fooptr->Foo::~Foo();
    fooptr->print();
    fooptr = new(foobar) Foo(2);   //  Ҵ 
    fooptr->print();
    fooptr->Foo::~Foo();           //   ʷ
                                   // fooptr delete  .
    fooptr->print();
    fooptr = new Foo;
    fooptr->print();
    delete fooptr;
    fooptr->print();
}
