/*
 * Wgraphics.h
 *              Motif/Lesstif graphics library widget header file
 *
 * Programmer: Park Jae-Ho(jrogue@netian.com), Lee Hai-Young
 *
 * This project is inspired by the WINIO library in UNDOCUMENTED WINDOWS.
 * This library can be copied, modified, used by others,
 * BUT PLEASE PROVIDE THAT ABOVE NOTICE APPEAR IN ALL COPIES OF THIS LIBRARY.
 */

#ifndef WGRAPHICS_H
#define WGRAPHICS_H


void WclearScreen ( MScreen *target );

int  Wgetmaxx ( MScreen *target );
int  Wgetmaxy ( MScreen *target );

void Wputpixel ( MScreen *target, int ix, int iy );
void Wline ( MScreen *target, int ixStart, int iyStart, int ixFinish, int iyFinish );

void Wsetnamedcolor ( MScreen *target, char *colorname ) ;
void Wsetnamedbkcolor ( MScreen *target, char *colorname ) ;


#endif
