/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

//************************************************************//
//                                                            //
//         :     S H A P E . H                            //
//                                                            //
//         Ŭ Shape  ̽                     //
//                                                            //
//************************************************************//

// Ŭ Shape ü ׷ Ű   ̴̽.
//  ٸ Ŭ ܼ    δ.

#ifndef _SHAPE_H
#define _SHAPE_H
#include "k.h"
#include "List.h"

//   
class ShapeRep;

class Shape: public Top {    // k.h  Top
public:
    //   rep Ѵ.
    ShapeRep *operator->() const {
        return rep;
    }

    // ڿ ǥ  
    Shape();
    Shape(ShapeRep&);
    ~Shape();
    Shape(Shape& x);
    Shape& operator=(Shape& x);

    //  ü Ÿ 
    Top *type();
    //  exemplar  exemplar üϸ,
    // ڰ  cutover Լ ȰϿ  νϽ Ѵ.
    void dataUpdate(Thingp&, const Thingp);

    // ڰ ϴ  ϵ   ִ  Լ
    Top *doit();

    // Shape ձ   ÷
    void gc();

    // exemplar ϴ ƾ, ׸ Shape ڽ ϴ ƾ
    void Register(ShapeRep*);
    void UnRegister(ShapeRep*);

    // Ŭ  ʱȭ Ѵ.
    static void init();    // Ŭ ʱȭ
private:
    friend ShapeRep;
    // operator new  ShapeRep ȣѴ.
    // operator delete  ʴ´.
    static void *operator new(size_t s) {
        return ::operator new(s);
    }
    static void operator delete(void *) { }

    // ڽ  νϽ  Ѵ.
    static List<Topp> *allShapes;

    // ShapeRep Ļ  ü exemplar  Ѵ.
    static List<Thingp> *allShapeExemplars;

    //  Shape   Ű 
    ShapeRep *rep;
};

typedef Shape *Shapepointer;

// Shape::init   Shape exemplar Ű 
extern Shape *shape;         // exemplar

class Point: public Shape {
public:
    // . . . .
    ShapeRep *operator->() const;
    Point();
    ~Point();
} point;

// ڴ ShapeRep     ʿ䵵, Ŭ ʿ䵵  Ѵ.

#include "ShapeRep.h"
#endif
